/*
 * fifo.h : a simple buffer for serial line connection between
 * a sender and a receiver.
 *
 * Copyright (C) 2000-2001 Laurent Vogel 
 * This file is part of EmulC, the Emulator on Curses library.
 *
 * This is free software covered by the GPL version 2 or later, and
 * comes with NO WARRANTY - read the file COPYING for details.  
 */

#ifndef _FIFO_H
#define _FIFO_H

struct fifo;

typedef struct fifo *Fifo;

Fifo fifo_new(void *receiver, void (*notify_func)(void *));
void fifo_send(Fifo f, int c);
void fifo_send_void(void *Fifo_f, int c);
int fifo_get_char(Fifo f);
int fifo_get_char_void(void *Fifo_f);

#endif /* _FIFO_H */
