/* This file is part of STonC, the Atari ST Emulator for Unix/X
 * ============================================================
 * STonX is free software and comes with NO WARRANTY - read the file
 * COPYING for details
 */
#ifndef UTILS_H
#define UTILS_H

#ifdef NO_BZERO
#define bzero(_x,_y) memset(_x,0,_y)
#endif

#ifdef NO_STRDUP
#define strdup(_x) strcpy(malloc(strlen(_x)+1),_x)
#endif

#if NO_CLEAN_EXIT
#define OnExit(_x)
#elif USE_ON_EXIT
#define OnExit(_x) (void)on_exit(_x,0)
#else
#define OnExit(_x) (void)atexit(_x)
#endif

extern void cleanup(int);


/*
 *  error reporting 
 */

extern void ec_stderr(const char *, ...);
extern void ec_fatal(const char *, ...);

#ifndef assert
#define assert(a) ((a)?1:ec_assert(#a, __FILE__, __LINE__))
extern void ec_assert(char *s, char *f, int l);
#endif

/*
 * user interface and configuration commands
 */

void ui_register_command(char *cmd, int (*func)(int,char**), char *help);
void ui_register_help(char *topic, char *help);


#endif /* UTILS_H */
